@ Program to read ASCII numbers, and write the integer values to stdout.
@ Usage: atoi [-b base] number [number...]


	.section	.text
strlen:
	push	{r4, r5}
	mov	r4, r0
next:
	ldrb	r5, [r4, #0]
	cmp	r5, #0
	beq	null
	add	r4, r4, #1	@ Incrementing str by one
	b	next
null:
	sub	r0, r4, r0	@ Subtract str from original pointer to get length
	pop	{r4, r5}
	bx	r14		@ End of the epilogue. Jumping back to caller via Link Register

strcpy:
	push	{fp}
	mov	fp, sp		@ save location of stack
	str	r0, [fp, #-8]	@ dst
	str	r1, [fp, #-12]	@ src
	b	assign
increment:
	ldr	r0, [fp, #-8]	@ increment dst by one
	add	r0, r0, #1
	str	r0, [fp, #-8]
	ldr	r0, [fp, #-12]	@ increment src by one
	add	r0, r0, #1
	str	r0, [fp, #-12]
assign:
	ldr	r0, [fp, #-12]	@ dst = src
	ldrb	r1, [r0, #0]
	ldr	r0, [fp, #-8]
	strb	r1, [r0, #0]
	ldr	r0, [fp, #-8]	@ test if dst is 0
	ldrb	r0, [r0, #0]
	cmp	r0, #0
	bne	increment
	ldr	r0, [fp, #-8]	@ return dst
	mov	sp, fp		@ restore location of stack
	pop	{fp}
	bx	lr

	.global	_start 
_start:
	mov	fp, sp
	sub	sp, sp, #1040	@ buffer of 1036 bytes
	sub	r0, fp, #1040
	str	r0, [fp, #-4]	@ last = buffer
	ldr	r0, [fp, #4]	@ length of string
	bl	strlen
	b	compare
copy:
	ldr	r0, [fp, #-4]	@ buf (dst)
	ldr	r1, [fp, #4]	@ argv (src)
	bl	strcpy
	ldr	r1, [fp, #-4]	@ len = dst - last
	rsb	r0, r1, r0
	add	r1, r1, r0	@ last += len
	str	r1, [fp, #-4]

	ldr	r1, [fp, #0]	@ last = if argc = 1, '\n', else ' '
	cmp	r1, #1
	moveq	r2, #10
	movne	r2, #32

	ldr	r1, [fp, #-4]
	strb	r2, [r1, #0]
	add	r1, r1, #1	@ increment last by one
	str	r1, [fp, #-4]
compare:
	ldr	r1, [fp, #4]	@ argv += len + 1
	add	r1, r1, r0
	add	r1, r1, #1
	str	r1, [fp, #4]
	ldr	r0, [fp, #0]	@ deincrement argc by one
	sub	r0, r0, #1
	str	r0, [fp, #0]
	cmp	r0, #0
	bne	copy
	ldr	r0, [fp, #-4]
	sub	r1, fp, #1040	@ buf
	rsb	r2, r1, r0	@ len = buf - last
	mov	r0, #1		@ File descriptor
        mov	r7, #4		@ Write syscall
        svc	#0
exit:
	mov	r7, #1		@ Exit syscall
        mov	r0, #0
	svc	#0
