@ Program to print all the arguments
.byte	0x7f
.byte	0x45	@ E
.byte	0x4c	@ L
.byte	0x46	@ F
.byte	0x01	@ 32 bit ; CLASS
.byte	0x01	@ lsb ; DATA
.byte	0x01	@ VERSION
.byte	0x00	@ None/System V ; OS ABI
.8byte	0x1000000000000000	@ ABI VERSION + PADDING
.2byte	0x02	@ ET_EXEC ; E_TYPE
.2byte	0x28	@ ARM ; E_MACHINE
.4byte	0x01	@ E_VERSION
.4byte	0x10054	@ E_ENTRY
.4byte	0x34	@ offset into program header ; E_PHOFF
.4byte	0x00	@ offset into section header ; E_SHOFF
.4byte	0x5000200	@ E_FLAGS
.2byte	0x34	@ ELF header size ; E_EHSIZE
.2byte	0x20	@ Program header size ; E_PHENTSIZE
.2byte	0x01	@ Number of program headers ; E_PHNUM
.2byte	0x00	@ Sections header size ; E_SHENTSIZE
.2byte	0x00	@ Number of section headers ; E_SHNUM
.2byte	0x00	@ Section header string table index ; E_SHSTRNSX

.4byte	0x01	@ PT_LOAD ; P_TYPE
.4byte	0x00	@ Offset of entry (52 + 32 = 84) ; P_OFFSET
.4byte	0x10000	@ P_VADDR
.4byte	0x00	@ P_PADDR
.4byte	0x124	@ P_FILESIZE
.4byte	0x124	@ P_MEMSZ
.4byte	0x05	@ R-X ; P_FLAGS
.4byte	0x10000	@ P_ALIGN

mov	fp, sp
sub	sp, sp, #1040	@ buffer of 1036 bytes
sub	r0, fp, #1040
str	r0, [fp, #-4]	@ last = buffer
ldr	r0, [fp, #4]	@ length of string
bl	strlen
b	compare

copy:
ldr	r0, [fp, #-4]	@ buf (dst)
ldr	r1, [fp, #4]	@ argv (src)
bl	strcpy
ldr	r1, [fp, #-4]	@ len = dst - last
rsb	r0, r1, r0
add	r1, r1, r0	@ last += len
str	r1, [fp, #-4]

ldr	r1, [fp, #0]	@ last = if argc = 1, '\n', else ' '
cmp	r1, #1
moveq	r2, #10
movne	r2, #32

ldr	r1, [fp, #-4]
strb	r2, [r1, #0]
add	r1, r1, #1	@ increment last by one
str	r1, [fp, #-4]

compare:
ldr	r1, [fp, #4]	@ argv += len + 1
add	r1, r1, r0
add	r1, r1, #1
str	r1, [fp, #4]
ldr	r0, [fp, #0]	@ deincrement argc by one
sub	r0, r0, #1
str	r0, [fp, #0]
cmp	r0, #0
bne	copy
ldr	r0, [fp, #-4]
sub	r1, fp, #1040	@ buf
rsb	r2, r1, r0	@ len = buf - last
mov	r0, #1		@ File descriptor
mov	r7, #4		@ Write syscall
svc	#0

mov	r7, #1		@ Exit syscall
mov	r0, #0
svc	#0

strlen:
push	{r4, r5}
mov	r4, r0

next:
ldrb	r5, [r4, #0]
cmp	r5, #0
beq	null
add	r4, r4, #1	@ Incrementing str by one
b	next

null:
sub	r0, r4, r0	@ Subtract str from original pointer to get length
pop	{r4, r5}
bx	r14		@ End of the epilogue. Jumping back to caller via Link Register

strcpy:
push	{fp}
mov	fp, sp		@ save location of stack
str	r0, [fp, #-8]	@ dst
str	r1, [fp, #-12]	@ src
b	assign

increment:
ldr	r0, [fp, #-8]	@ increment dst by one
add	r0, r0, #1
str	r0, [fp, #-8]
ldr	r0, [fp, #-12]	@ increment src by one
add	r0, r0, #1
str	r0, [fp, #-12]

assign:
ldr	r0, [fp, #-12]	@ dst = src
ldrb	r1, [r0, #0]
ldr	r0, [fp, #-8]
strb	r1, [r0, #0]
ldr	r0, [fp, #-8]	@ test if dst is 0
ldrb	r0, [r0, #0]
cmp	r0, #0
bne	increment
ldr	r0, [fp, #-8]	@ return dst
mov	sp, fp		@ restore location of stack
pop	{fp}
bx	lr
