	.set	basenum, 209867295
	.section .data
outstr:
	.fill	11		@ the max output size is 10 digits,
				@ the 11th byte is for line ending

	.section .text
@ r0 = base, r1 = exponent
pow:
	cmp	r1, #0		@ test if exponent is zero
	moveq	r2, #1		@ if true, total will be one
	beq	pow_end
	mov	r2, r0		@ copy base to total
	sub	r1, #1		@ subtract one from exponent since base
				@ was copied
pow_loop:
	cmp	r1, #0		@ test if multiplication is needed again
	ble	pow_end		@ leave if equal or less than zero
	mul	r2, r0, r2	@ multiply total by base and store in total
	sub	r1, #1		@ decrement exponent
	b	pow_loop
pow_end:
	mov	r0, r2		@ move result to r0
	bx	lr

	.global _start
_start:
	ldr	r4, =outstr	@ load outstr address
	ldr	r5, =basenum	@ load number to process. Because
				@ its large than an immediate it
				@ must be loaded
	mov	r7, #9		@ initial power of 10
	mov	r8, #0		@ initialize loop counter

findstart:
	mov	r0, #10
	mov	r1, r7
	bl	pow		@ get current power of ten
	mov	r6, r0		@ move result to r6
	cmp	r6, r5		@ compare 10^x to number to print
	ble	finddigit	@ if less than number, go to print
	sub	r7, #1		@ else decrement power and try again
	b	findstart

finddigit:
	cmp	r5, r6		@ compare remaining number to 10^x
	blt	write		@ if less than, write digit
	add	r8, r8, #1	@ increment counter
	sub	r5, r5, r6	@ subtract 10^x from remaining and go again
	b	finddigit
write:
	add	r8, #'0'	@ add counter to ASCII zero to get number
	strb	r8, [r4], #1	@ store in outstr and increment
	sub	r7, #1		@ subtract one from the counter
	cmp	r7, #0		@ compare exponent to zero
	blt	exit		@ if exponent is less than zero, break loop
	mov	r0, #10
	mov	r1, r7
	bl	pow		@ get next power of ten
	mov	r6, r0		@ move 10^x into r6
	mov	r8, #0		@ reset loop counter
	b	finddigit
exit:
	mov	r8, #'\n'	@ load line ending for output string
	strb	r8, [r4]	@ store to output, no need to increment

	@ Write system call
	mov	r7, #4		@ 4 = write
	mov	r0, #1		@ 1 = stdout
	ldr	r1, =outstr	@ load outstr address
	mov	r2, #11		@ 11 = maximum length
	svc	#0

	@ Exit system call
	mov	r7, #1		@ 1 = exit
	mov	r0, #0		@ 0 = status code
	svc	#0
