@ Tiny shell for Linux

	.section	.rodata
default_path:
	.ascii	"/bin:/usr/bin\0"

	.section	.text
strchr:
	str	fp, [sp, #-4]!
	mov	fp, sp			@ save location of stack
	sub	sp, sp, #12
	str	r0, [fp, #-8]		@ str
	str	r1, [fp, #-12]		@ ch
	b	compare
strchr_incr:
	ldr	r0, [fp, #-8]		@ increment str by 1
	add	r0, r0, #1
	str	r0, [fp, #-8]
compare:
	ldr	r0, [fp, #-8]		@ test if str != 0
	ldrb	r0, [r0]
	cmp	r0, #0
	beq	strchr_ret
	ldr	r0, [fp, #-8]		@ test if str != ch
	ldrb	r0, [r0]
	ldr	r1, [fp, #-12]
	cmp	r0, r1
	bne	strchr_incr
strchr_ret:
	ldr	r0, [fp, #-8]		@ if str = ch, str, else 0
	ldrb	r0, [r0]
	ldr	r1, [fp, #-12]
	cmp	r0, r1
	movne	r0, #0
	ldreq	r0, [fp, #-8]
	mov	sp, fp			@ restore location of stack
	ldr	fp, [sp], #4
	bx	lr

strcpy:
	push	{fp}
	mov	fp, sp			@ save location of stack
	str	r0, [fp, #-8]		@ dst
	str	r1, [fp, #-12]		@ src
	b	assign
strcpy_incr:
	ldr	r0, [fp, #-8]		@ increment dst by 1
	add	r0, r0, #1
	str	r0, [fp, #-8]
	ldr	r0, [fp, #-12]		@ increment src by 1
	add	r0, r0, #1
	str	r0, [fp, #-12]
assign:
	ldr	r0, [fp, #-12]		@ dst = src
	ldrb	r1, [r0, #0]
	ldr	r0, [fp, #-8]
	strb	r1, [r0, #0]
	ldr	r0, [fp, #-8]		@ test if dst != 0
	ldrb	r0, [r0, #0]
	cmp	r0, #0
	bne	strcpy_incr
	ldr	r0, [fp, #-8]		@ return dst
	mov	sp, fp			@ restore location of stack
	pop	{fp}
	bx	lr

search_path:
	stmfd	sp!, {fp, lr}
	add	fp, sp, #4
	sub	sp, sp, #32
	str	r0, [fp, #-24]		@ Save file_name
	str	r1, [fp, #-28]		@ Save pathp
	str	r2, [fp, #-32]		@ Save buff

	ldr	r0, [fp, #-28]		@ path = *pathp
	ldr	r0, [r0]
	str	r0, [fp, #-8]
	b	compare_path
path_not_null:
	mov	r1, #':'
	ldr	r0, [fp, #-8]
	bl	strchr
	str	r0, [fp, #-12]		@ prefix = ret

	ldr	r0, [fp, #-12]
	cmp	r0, #0
	beq	no_null

	ldr	r0, [fp, #-12]		@ *prefix = '\0'
	mov	r1, #0
	strb	r1, [r0]
no_null:
	ldr	r0, [fp, #-32]		@ pass buff
	ldr	r1, [fp, #-8]		@ pass path
	bl	strcpy
	str	r0, [fp, #-8]		@ prefix = ret

	ldr	r0, [fp, #-8]		@ *path = '/'
	mov	r1, #'/'
	strb	r1, [r0]

	ldr	r0, [fp, #-8]		@ path++
	add	r0, r0, #1
	str	r0, [fp, #-8]

	ldr	r0, [fp, #-8]		@ pass path
	ldr	r1, [fp, #-24]		@ pass file_name
	bl	strcpy

	mvn	r0, #99			@ AT_FDCWD
	ldr	r1, [fp, #-32]		@ pass buff
	mov	r2, #1			@ X_OK
	mov	r3, #0
	ldr	r7, sys_faccessat	@ Faccessat syscall
	svc	#0
	str	r0, [fp, #-16]

	ldr	r3, [fp, #-12]
	cmp	r3, #0
	beq	no_colon

	ldr	r0, [fp, #-12]		@ *prefix++ = ':'
	add	r1, r0, #1
	str	r1, [fp, #-12]
	mov	r1, #':'
	strb	r1, [r0]
no_colon:
	ldr	r0, [fp, #-16]
	cmp	r0, #0
	bne	does_not_exist

	ldr	r0, [fp, #-28]		@ *pathp = prefix
	ldr	r1, [fp, #-12]
	str	r1, [r0]
	mov	r0, #0
	b	search_path_ret
does_not_exist:
	ldr	r0, [fp, #-12]		@ path = prefix
	str	r0, [fp, #-8]
compare_path:
	ldr	r0, [fp, #-8]
	cmp	r0, #0
	bne	path_not_null	
	mov	r0, #1
search_path_ret:
	sub	sp, fp, #4
	ldmfd	sp!, {fp, pc}
sys_faccessat:
	.word	334

execvpe:
	stmfd	sp!, {fp, lr}           @ Save frame pointer and link register to stack pointer
	add	fp, sp, #4
	sub	sp, sp, #168		@ Allocate space for variables
	str	r0, [fp, #-160]		@ Save file_name (*argv)
	str	r1, [fp, #-164]		@ Save argv
	str	r2, [fp, #-168]		@ Save envp
	ldr	r3, buffer_location
buffer_target:
	add	r3, pc, r3
	sub	ip, fp, #24
	ldmia	r3, {r0, r1, r2, r3}
	stmia	ip!, {r0, r1, r2}
	strh	r3, [ip]
	ldr	r0, [fp, #-160]
	mov	r1, #'/'
	bl	strchr

	cmp	r0, #0
	beq	not_absolute
	ldr	r0, [fp, #-160]
	ldr	r1, [fp, #-164]
	ldr	r2, [fp, #-168]
	mov	r7, #11			@ Execve syscall
	svc	#0
	b	execvpe_fin
not_absolute:
	sub	r3, fp, #24
	str	r3, [fp, #-8]
	sub	r2, fp, #152
	sub	r3, fp, #8
	mov	r1, r3
	ldr	r0, [fp, #-160]
	bl	search_path

	cmp	r0, #0
	bne	no_path
	sub	r0, fp, #152
	ldr	r1, [fp, #-164]
	ldr	r2, [fp, #-168]
	mov	r7, #11			@ Execve syscall
	svc	#0
	b	execvpe_fin
no_path:
	ldr	r0, [fp, #-160]
	ldr	r1, [fp, #-164]
	ldr	r2, [fp, #-168]
	mov	r7, #11			@ Execve syscall
	svc	#0
execvpe_fin:
	sub	sp, fp, #4
	ldmfd	sp!, {fp, pc}
buffer_location:
	.word	default_path-(buffer_target+8)

	.global	_start
_start:
	pop	{r0}			@ argc is on the stack
	mov	r1, sp			@ argv = sp
	add	r2, r1, r0, lsl #2	@ envp = argv + (4 * argc)
	add	r2, r2, #4		@ skip null byte
	and	r3, r1, #-8		@ sp must be 8-byte aligned

	mov	fp, sp			@ Initialize frame pointer
	add	r1, r1, #4		@ pass ++argv as second argument
	ldr	r0, [r1, #0]		@ pass *argv as first argument
	bl	execvpe

	mov	r0, #0
	mov	r7, #1			@ Exit syscall
	svc	#0
