# should be a replacement for /bin/cat
	.data
argc:
	.long	0
exit_status:
	.byte   0

	# registers used:
	#
	#    eax = 
	#    ebx = *argv
	#    ecx = 
	#    edx = 
	#    esi = bytes written?
	#    edi = argc
	
buffer:
	.space	4096, 0

	.text
	.global	_start

_start:
#	xor	%r10,%r10	# we'll use %r10 for our "zero" register
#	xor	%r11,%r11	# exit status, change it if and when we have an error
	
	popl	%edi		# this is argc
	movl	%edi, argc
	popl	%ebx		# remove command, throw it away
	decl	argc
	jz	finish		# check for no args left in argv

around:
	popl	%ebx		# this is the next *argv --- could test here since you are through when this a NULL pointer!

	cmpb	$0, (%ebx)	# check to see if this just an empty string (so we don't do a separator)
	jz	shortcut	# if that's just a zero byte at the beginning, skip it...
	
	call	fileout	# now go ahead and "cat" this file

shortcut:	
	decl	argc
	jnz	around

finish:
	movb	exit_status, %bl		# and exit with a status
	movl	$1, %eax	
	int	$0x80


# fileout : open a file, write its contents to stdout, close the file, return
#
#    %ebx -- the name of a file (terminated by \0) in
#    trashes all registers except %edi
fileout:
	movl	$0, %ecx	# now set up the file access argument to O_RDONLY (argument 2, see /usr/include/asm-generic)
	#movl	$0, %edx	# shouldn't come into play, but to be safe...
	movl	$5, %eax	# now let's specify open syscall
	int	$0x80

	cmpb	$0, %al		# check to see if it's zero
	jl	out		# not zero, must have been a problem

	# okay, the file opened all right, now we need to write everything to standard out...
	movl	%eax, %edi	# save file descriptor for subsequent rounds

	# read one buffer
read_loop:	
	movl	%edi, %ebx 	# move saved file descriptor to first argument
	leal	buffer, %ecx	# now point toward the buffer
	movl	$4096, %edx	# now say how many bytes are in that buffer
	movl	$3, %eax	# read syscall
	int	$0x80

	cmpl	$0, %eax	# what did we get back?
	jle	err_out

	# time to write
	movl	%eax, %esi	# bytes left to write saved to %esi
	movl	$1, %ebx	# okay, send it out stdout...
	leal	buffer, %ecx	# set up the buffer
	movl	%eax, %edx	# Now for the number of bytes... 

sendit:	
	movl	$4, %eax	# syscall is write 
	int	$0x80

	# okay, we have bytes written in %rax:
	#
	#   case eax == esi, finished!
	#   case eax < 0, finished!
	#   otherwise need to reduce count with  edx = edx - eax,
	#   increment buffer pointer ecx = ecx + eax
	#   increment count %esi = %esi + %eax
	cmpl	%eax, %esi
	jz	read_loop
	negl	%eax
	jz	err_out
	subl	%eax, %edx	# count down
	addl	%eax, %ecx	# move the buffer pointer
	addl	%eax, %esi	# update the check value
	jmp	sendit

err_out:
	movb	%al, exit_status
out:
	ret
