# should be a replacement for /bin/cmp
	.data
argc:				# argument count
	.long 	0
argv:				# pointer to arguments
	.long 	0
exit_status:			# exit status, initially zero, change it if and when we have an error
	.long	0
byte_counter:			# byte counter
	.long 	1
line_counter:			# line counter
	.long 	1
fd1:				# file descriptor 1
	.long	0
fd2:				# file descriptor 2
	.long 	0
buffer0:
	.space	4096,0
buffer1:
	.space	4096,0

	.text
	.global	_start

_start:
	pop	%eax		# this is argc...
	cmp	$3,%eax		# check that we have the right number of arguments
	jne	error_finish

	pop 	%ebx		# remove command
	dec	%eax
	jz	finish		# check for no args left in argv

	# open first file
	mov	$0,%ecx		# not "xor" since we want to make it clear that this is $0 = O_RDONLY, not just any zero!
	pop	%ebx		# this is the next *argv --- go ahead and put it in %rdi since we are going to try to open it for reading
	mov	$5 ,%eax	
	int	$0x80
	cmp	$0, %eax
	jl	error_finish
	mov	%eax, fd1	# save file descriptor in fd1

	# open second file
	mov	$0, %ecx	# not "xor" since we want to make it clear that this is $0 = O_RDONLY, not just any zero!
	pop	%ebx		# this is the next *argv --- go ahead and put it in %rdi since we are going to try to open it for reading
	mov	$5 ,%eax	
	int	$0x80
	cmp	$0, %eax
	jl	error_finish

	mov	%eax, fd2	# save file descriptor in fd2

loop:
	# read one byte from file 0 into buffer0
	mov	fd1, %ebx	# recover file descriptor from %r14
	lea	buffer0, %ecx	# buffer location
	mov	$1, %edx	# how many bytes
	mov	$3 ,%eax
	int	$0x80
	cmp	$0, %eax
	jl	error_finish
	je	file0_finish

	# read one byte from file 1 into buffer1
	mov	fd2, %ebx	# recover file descriptor from %r15
	lea	buffer1, %ecx	# buffer location
	mov	$1, %edx		# how many bytes
	mov	$3, %eax
	int	$0x80
	cmp	$0, %eax
	jl	error_finish
	je	file1_finish

	mov	(buffer0), %eax
	cmp	%eax, (buffer1)
	jne	difference_found

	incl	byte_counter	# byte count

	# check to see if end-of-line
	cmp	$12, %eax 	# if memory serves...
	jne	loop
	incl	byte_counter		# line count
	jmp	loop

file0_finish:
	# check to see if file2 is finished also --> if so, same
	#                                        --> if not, then different
	mov	fd2, %ebx
	lea	buffer1, %ecx
	mov	$1, %edx
	mov	$3 ,%eax
	int	$0x80
	cmp	$0, %eax
	je	finish
	jl	error_finish
	# or we fall through to "different" finish
	
file1_finish:
difference_found:
	mov	$1,%ebx
	mov	$1, %eax	# int	$0x80 = 60 is exit
	int	$0x80

error_finish:
	mov	$2, %ebx
	mov	$1, %eax	# int	$0x80 = 60 is exit
	int	$0x80


finish:
	mov	exit_status, %ebx	# and exit with a status
	mov	$1, %eax		# 
	int	$0x80
