#!/bin/sh
CFLAGS="-fno-unwind-tables -std=c89 -Wpedantic -Wall"
LIB_FLAGS="libcgi.a"
PREFIX="/usr/local"

: ${CC:=fndn-gcc}
: ${AS:=as}
: ${AR:=ar}
: ${PREFIX:=/usr/local}

run() {
  printf '%s\n' "$*"
  "$@"
}
 
install() {
  [ -f cgi.o ] || build

  run mkdir -p "${PREFIX}/lib"
  run mkdir -p "${PREFIX}/share/doc/libcgi"
  run install -m 644 COPYING README "${PREFIX}/share/doc/libcgi"
  run install -m 644 cgi.o "${PREFIX}/lib/"
  run cp -af include "$PREFIX"
}

uninstall() {
  run rm -fr "${PREFIX}/share/doc/libcgi" "${PREFIX}/include/cgi.h"
  run rm -f "${PREFIX}/lib/cgi.o"
}

cgitest.cgi() {
  [ -f libcgi.a ] || build

  if !(chdir libfndn && ./build.sh); then
    echo "Abort." >&2
    exit 1
  fi 
  run "$CC" $CFLAGS -c -o cgitest.o cgitest.c
  run "$CC" $LDFLAGS -o cgitest.cgi cgitest.o $LIB_FLAGS
}

build() {
  run "$CC" $CFLAGS -c -o cgi.o cgi.c
  run "$AR" cr libcgi.a cgi.o
  cgitest.cgi
}

clean() {
  (chdir libfndn && ./build.sh clean)
  rm -f cgi.o cgitest.o cgitest.cgi
}

if [ "$#" -gt 0 ]; then
  if ! type $1 | grep -q "function$"; then
    echo "$(basename $0): Unknown verb: $1" >&2
    exit 1
  else
    "$@"
  fi
else
  build
fi
