#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cgi.h"

static void name(void)
{
	char name[81];

	cgi_form_string_no_newlines("name", name, 81);
	put(1, "Name: ");
	cgi_xhtml_escape(name, strlen(name));
	put_line(1, "<br />\n");
}

static void comment(void)
{
	char comment[256];

	cgi_form_string("comment", comment, 256);
	put_line(1, "Comment: <pre>\n");
	cgi_xhtml_escape(comment, strlen(comment));
	put_line(1, "</pre>\n");
}

static void hungry(void)
{
	if (cgi_form_checkbox_single("hungry") == form_success) {
		put_line(2, "I'm Hungry!<br />");
		return;
	}
	put_line(1, "I'm Not Hungry!<br />");
}
	
static void frogs(void)
{
	char buffer[8];
	int frogs_eaten;

	cgi_form_integer("frogs", &frogs_eaten, 0);
	put(1, "I have eaten ");
	itoa(frogs_eaten, buffer, 10);
	put(1, buffer);
	put_line(1, " frogs.<br />");
}

static void color(void)
{
	int color_choice;
	char *colors[3] = { "Red", "Green", "Blue" };

	cgi_form_select_single("colors", colors, 3, &color_choice, 0);
	put(1, "I am: ");
	put(1, colors[color_choice]);
	put(1, "<br />\n");
}

static void flavors(void)
{
	int flavor_choices[3];
	int i;
	int result;
	int invalid;
	char *flavors[3] = { "pistachio", "walnut", "creme" };

	result = cgi_form_select_multiple("flavors", flavors, 3, flavor_choices,
		&invalid);
	if (result == form_not_found) {
		put_line(1, "<p>I hate ice cream.</p>");
		return;
	}
	put_line(1, "My favorite ice cream flavors are:\n");
	put_line(1, "<ul>\n");
	for (i = 0; i < 3; i++) {
		if (flavor_choices[i]) {
			put(1, "<li>");
			put(1, flavors[i]);
			put_line(1, "</li>");
		}
	}
	put_line(1, "</ul>");
}

static void radio_buttons(void)
{
	int age_choice;
	char age_text[10];
	char *ages[4] = { "1", "2", "3", "4" };

	cgi_form_select_single("age", ages, 4, &age_choice, 0);
	put(1, "Age of Truck: ");
	put(1, ages[age_choice]);
	put_line(1, " (method #1)<br />");

	cgi_form_string("age", age_text, 10);
	put(1, "Age of Truck: ");
	put(1, age_text);
	put_line(1, " (method #2)<br />");
}

static void entries(void)
{
	char **array, **array_step;

	put_line(1, "List of All Submitted Form Field Names:<br />");
	if (cgi_form_entries(&array) != form_success)
		return;
	array_step = array;
	put_line(1, "<ul>\n");
	while (*array_step) {
		put(1, "<li>");
		cgi_xhtml_escape(*array_step, strlen(*array_step));
		put_line(1, "</li>");
		array_step++;
	}
	put_line(1, "</ul>");
	cgi_string_array_free(array);
}

static void show_form(char **envp)
{
	char *script_name = getenv(envp, "SCRIPT_NAME");

	put(1, "<form method=\"POST\" action=\"");
	cgi_value_escape(script_name, strlen(script_name));
	put(1, "\">\n");
	put(1, "<p>Text Field containing Plaintext</p>\n");
	put(1, "<input type=\"text\" name=\"name\" />Your Name\n");
	put(1, "<p>Multiple-Line Text Field</p>\n");
	put(1, "<textarea name=\"comment\" rows=\"4\" cols=\"40\">\n");
	put(1, "  Write your comment here.</textarea>\n");
	put(1, "<p>Checkbox</p>\n");
	put(1, "<input type=\"checkbox\" name=\"hungry\" checked=\"checked\" .>Hungry\n");
	put(1, "<p>Text Field containing an Integer Value</p>\n");
	put(1, "<input type=\"text\" name=\"frogs\" value=\"1\">\n");
	put(1, "Frogs Eaten\n");
	put(1, "<p>Single-SELECT</p><br />\n");
	put(1, "<select name=\"colors\">\n");
	put(1, "  <option value=\"Red\">Red\n");
	put(1, "  <option value=\"Green\">Green\n");
	put(1, "  <option value=\"Blue\">Blue\n");
	put(1, "</select><br />\n");
	put(1, "Multiple-SELECT<br />\n");
	put(1, "<select name=\"flavors\" multiple>\n");
	put(1, "  <option value=\"pistachio\">Pistachio\n");
	put(1, "  <option value=\"walnut\">Walnut\n");
	put(1, "  <option value=\"creme\">Creme\n");
	put(1, "</select>\n");
	put(1, "<p>Exclusive Radio Button Group: Age of Truck in Years</p>\n");
	put(1, "<input type=\"radio\" name=\"age\" value=\"1\" />1\n");
	put(1, "<input type=\"radio\" name=\"age\" value=\"2\" />2\n");
	put(1, "<input type=\"radio\" name=\"age\" value=\"3\" />3\n");
	put(1, "<input type=\"radio\" name=\"age\" value=\"4\" />4\n");
	put(1, "</form>\n");
}

int cgi_main(int argc, char **argv, char **envp)
{
	cgi_header_content_type("application/xhtml+xml");

	put_line(1, "<html>\n<head>");
	put_line(1, "  <title>CGI Test</title>\n</head>");
	put_line(1, "\n<body>\n  <h1>CGI Test</h1>");

	/* If a submit button has already been clicked, act on the submission of the
	 * form.
	 */
	if (cgi_form_checkbox_single("testcgi") == form_success) {
		name();
		comment();
		hungry();
		frogs();
		color();
		flavors();
		radio_buttons();
		entries();
		put_line(1, "<hr />\n");
	}
	show_form(envp);
	put_line(1, "</body>\n</html>");
	return 0;
}
