#ifndef SIGNAL_H
#define SIGNAL_H

#define SIGHUP	1
#define SIGINT	2
#define SIGQUIT	3
#define SIGILL	4
#define SIGABRT	6
#define SIGFPE	8
#define SIGKILL	9
#define SIGUSR1	10
#define SIGSEGV	11
#define SIGUSR2	12
#define SIGPIPE	13
#define SIGALRM	14
#define SIGTERM	15
#define SIGCHLD	17
#define SIGCONT	18
#define SIGTSTP	20

#define SIG_DFL (void)(*)(int))0
#define SIG_IGN (void(*)(int))1

union sigval {
	int sival_int;
	void *sival_ptr;
};

struct sigset {
	unsigned long int val[16];
};

struct sigaction {
	/* Pointer to a signal-catching function or one of the macros SIG_IGN or SIG_DFL. */
	void (*sa_handler)(int);

	/* Set of signals to be blocked during execution of the signal handling function. */
	struct sigset sa_mask;

	/* Special flags. */
	int sa_flags;

	/* Pointer to a signal-catching function. */
	void (*sa_restorer)(void);
};

int kill(int fd, int sig);
int rt_sigaction(int sig, const struct sigaction *act, struct sigaction *oldact);
int signal(int sig, void (*handler)(int));
int raise(int sig);

#endif
