#ifndef SOCKET_H
#define SOCKET_H

#define SOCK_STREAM 1
#define SOCK_DGRAM 2
#define SOCK_RAW 3

#define AF_UNSPEC 0
#define AF_UNIX 1
#define AF_INET 2

struct sockaddr {
	unsigned short sa_family;
	char sa_data[14];
};

struct in_addr {
	const char *s_addr;
};

struct sockaddr_in {
	unsigned short sin_port;
	struct in_addr sin_addr;
	char sin_zero[sizeof(struct sockaddr) -
		sizeof(unsigned short) -
		sizeof(struct in_addr)];
};

struct sockaddr_un {
	unsigned short sun_family;
	char sun_path[108];
};

extern int socket(int domain, int type, int protocol);
extern int connect(int sockfd, const struct sockaddr *addr, unsigned int addrlen);
extern int accept(int sockfd, struct sockaddr *addr, unsigned int *addrlen);
extern int listen(int sockfd, int backlog);
extern int bind(int sockfd, const struct sockaddr *addr, unsigned int addrlen);

#endif
