#ifndef STAT_H
#define STAT_H

#define S_IFMT 0170000

#define S_IFDIR 0040000
#define S_IFCHR 0020000
#define S_IFBLK 0060000
#define S_IFREG 0100000
#define S_IFIFO 0010000
#define S_IFLNK 0120000
#define S_IFSOCK 0140000

#define S_IRUSR 00400 /* read by owner. */
#define S_IWUSR 00200 /* write by owner. */
#define S_IXUSR 00100 /* execute by owner. */
#define S_IRGRP 00040 /* read by group. */
#define S_IWGRP 00020 /* write by group. */
#define S_IXGRP 00010 /* execute by group. */
#define S_IROTH 00004 /* read by others. */
#define S_IWOTH 00002 /* write by others. */
#define S_IXOTH 00001 /* execute by others. */

struct stat {
	unsigned int st_dev;
	long st_ino;
	unsigned int st_mode;
	long st_nlink;
	unsigned int st_uid;
	unsigned int st_gid;
	int st_size;
	int st_blksize;
	int st_blocks;
};

extern int fstatat64(int dirfd, const char *pathname, struct stat *statbuf, int flags);
extern int chmod(const char *pathname, int mode);
extern int fchmod(int fd, int mode);

#endif
