#ifndef UNISTD_H
#define UNISTD_H

#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2

int read(int fd, void *buf, unsigned int count);
int write(int fd, const void *buf, unsigned int count);
int close(int fd);
int unlink(const char *pathname);
void exit(int status);
int chdir(const char *path);
int getcwd(char *buf, unsigned int size);
int execve(const char *pathname, char * const *argv, char * const *envp);
int chown(const char *pathname, unsigned int owner, unsigned int group);
int fchown(int fd, unsigned int owner, unsigned int group);
int setsid(void);
int dup3(int oldfd, int newfd, int flags);
int lseek(int fd, int offset, int whence);
int readlinkat(int dirfd, const char *path, char *buf, unsigned int bufsize);
int brk(void *addr);
void *sbrk(int inc);
int fork(void);
int ttyname(int fd, char *name, unsigned int size);
int access(const char *pathname, int mode);
int getpid(void);

#endif
