#include <errno.h>
#include <string.h>

int atoi(const char *str, char **endptr, int base)
{
	char c;
	int cutlim, i;
	int any = 0;
	int acc = 0;
	int cutoff = 0xffffffff;

	for (i = 0; str[i] == ' '; i++);
	if (base < 2 || base > 36)
		return -EINVAL - ATOI_MIN;
	cutlim = cutoff / base;
	cutoff %= base;
	while ((c = str[i++])) {
		if (c >= '0' && c <= '9')
			c -= '0';
		else if (c >= 'A' && c <= 'Z')
			c -= 'A' - 10;
		else if (c >= 'a' && c <= 'z')
			c -= 'a' - 10;
		else
			break;
		if (c >= base)
			break;
		if (any < 0 || acc > cutoff || (acc == cutoff && c > cutlim)) {
			any = -1;
		} else {
			any = 1;
			acc *= base;
			acc += c;
		}
	}
	if (any < 0)
		return -ERANGE - ATOI_MIN;
	*endptr = (char *)str + i - 1;

	return acc;
}
