#!/bin/sh

CFLAGS="-fno-unwind-tables -std=c89 -Wpedantic -Wall -Werror"

: ${CC:=fndn-gcc}
: ${LD:=fndn-gcc}

run() {
  printf '%s\n' "$*"
  "$@"
}

build() {
  if !(cd .. && ./build.sh); then
    echo "Abort." >&2
    exit 1
  fi
  for source in $(ls -1 *.c | cut -d'.' -f1); do
    run "$CC" $CFLAGS -c -o "${source}.o" "${source}.c"
    run "$LD" $LDFLAGS -o "$source" "${source}.o"
  done
}

clean() {
  (cd .. && ./build.sh clean)
  for source in $(ls -1 *.c | cut -d'.' -f1); do
    executables="$source $executables"
  done
  run rm -f *.o $executables
}

if [ "$#" -gt 0 ]; then
  if ! type $1 | grep -q "function$"; then
    echo "$(basename $0): Unknown verb: $1" >&2
    exit 1
  else
    "$@"
  fi
else
  build
fi
