#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>
#include <time.h>

int main(void)
{
	int pid;
	struct timespec ts;

	pid = fork();

	if (pid < 0) {
		put(2, "fork: ");
		put_line(2, strerror(-pid));
		return 1;
	}
	if (pid > 0) {
		waitpid(pid, NULL, 0);
		put_line(1, "Parent exiting");
		return 0;
	}
	ts.tv_sec = 1;
	ts.tv_nsec = 0;

	put_line(1, "Child is sleeping...");
	nanosleep(&ts, NULL);
	put_line(1, "Child exiting");
	return 0;
}
