#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

/* Test get_line(), open(), lseek(), close(), and unlink() */
int main(void)
{
	const char *tempfile = { "/tmp/test.txt" };
	const char *outstr = { "A line\n" };
	char buf[10];
	int ret;
	int fd;

	put_line(1, "Beginnning I/O test");
	fd = open(tempfile, O_RDWR | O_CREAT, 0666);
	if (fd < 0) {
		put(2, "Failed to write temporary file: ");
		put_line(2, strerror(-fd));
		return 1;
	}
	put(fd, outstr);
	ret = lseek(fd, SEEK_SET, 0);
	if (ret < 0) {
		put(2, "Failed to seek beginning of file: ");
		put_line(2, strerror(-ret));
		return 1;
	}
	get_line(fd, buf, sizeof(buf));
	close(fd);
	ret = unlink(tempfile);
	if (ret < 0) {
		put(2, "Failed to unlink file: ");
		put_line(2, strerror(-ret));
		return 1;
	}
	if (strcmp(buf, outstr) != 0) {
		put_line(2, "Input does not match output");
		return 1;
	}
	put_line(1, "Success");

	return 0;
}
